unit ApiHook;

interface

uses
  Windows, WinSock, MainForm, SysUtils;

type
  PDATA = ^TDATA;
  TDATA = packed record
    Hook: HHOOK;
    HookData: HHOOK;
    Hooked: Boolean;
  end;

  TSockProc = function(s: TSocket; var buf; len, flags: Integer): Integer; stdcall;

  PJmpCode = ^TJmpCode;
  TJmpCode = packed record
    JmpCode: Byte;
    Address: TSockProc;
    MovEAX: array[0..2] of Byte;
  end;

  procedure HookAPI;
  procedure UnHookAPI;
  procedure NumToStr(var pData: string);

var
  OldSend, OldRecv: TSockProc;
  JmpCode: TJmpCode;
  OldProc: array[0..1] of TJmpCode;
  AddSend, AddRecv: Pointer;
  TmpJmp: TJmpCode;
  ProcessHandle: THandle;

implementation

function MySend(s: TSocket; var buf; len, flags: Integer): Integer; stdcall;
var
  dwSize: DWORD;
  packet: string;
begin
  if frmMain.chkSend.Checked then begin
//    packet := NumToStr(buf, len);
    SetLength(packet, len);
    Move(buf, packet[1], len);
    NumToStr(packet);
    frmMain.lbxSend.Items.Add(packet);
  end;
  WriteProcessMemory(ProcessHandle, AddSend, @OldProc[0], 8, dwSize);
  Result := OldSend(s, buf, len, flags);
  JmpCode.Address := @MySend;
  WriteProcessMemory(ProcessHandle, AddSend, @JmpCode, 8, dwSize);
end;

function MyRecv(s: TSocket; var buf; len, flags: Integer): Integer; stdcall;
var
  dwSize: DWORD;
  packet: string;
begin
  if frmMain.chkRecv.Checked then begin
//    packet := NumToStr(buf, len);
    SetLength(packet, len);
    Move(buf, packet[1], len);
    NumToStr(packet);
    frmMain.lbxRecv.Items.Add(packet);
  end;
  WriteProcessMemory(ProcessHandle, AddRecv, @OldProc[1], 8, dwSize);
  Result := OldRecv(s, buf, len, flags);
  JmpCode.Address := @MyRecv;
  WriteProcessMemory(ProcessHandle, AddRecv, @JmpCode, 8, dwSize);
end;

procedure HookAPI;
var
  DllModule: THandle;
  dwSize: Cardinal;
begin
  ProcessHandle := GetCurrentProcess;
  DllModule := LoadLibrary('ws2_32.dll');
  AddSend := GetProcAddress(DllModule, 'send');
  AddRecv := GetProcAddress(DllModule, 'recv');
  JmpCode.JmpCode := $B8;
  JmpCode.MovEAX[0] := $FF;
  JmpCode.MovEAX[1] := $E0;
  JmpCode.MovEAX[2] := 0;
  ReadProcessMemory(ProcessHandle, AddSend, @OldProc[0], 8, dwSize);
  JmpCode.Address := @MySend;
  WriteProcessMemory(ProcessHandle, AddSend, @JmpCode, 8, dwSize);
  ReadProcessMemory(ProcessHandle, AddRecv, @OldProc[1], 8, dwSize);
  JmpCode.Address := @MyRecv;
  WriteProcessMemory(ProcessHandle, AddRecv, @JmpCode, 8, dwSize);
  OldSend := AddSend;
  OldRecv := AddRecv;
end;

procedure UnHookAPI;
var
  dwSize: Cardinal;
begin
  WriteProcessMemory(ProcessHandle, AddSend, @OldProc[0], 8, dwSize);
  WriteProcessMemory(ProcessHandle, AddRecv, @OldProc[1], 8, dwSize);
end;

procedure NumToStr(var pData: string);
var
  i: Integer;
  tmpStr: string;
begin
  tmpStr := '';
  for i := 1 to Length(pData) do begin
    tmpStr := tmpStr + Format('%x ', [Ord(pData[i])]);
  end;
  pData := tmpStr;
end;

end.
